// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#pragma once

#include <emper-config.h>

#include <string>

namespace emper {

static const bool STATS =
#ifdef EMPER_STATS
		true
#else
		false
#endif
		;

static const bool WORKER_SLEEP =
#ifdef EMPER_WORKER_SLEEP
		true
#else
		false
#endif
		;

enum class WorkerWakeupStrategy {
	one,
	all,
};

static const enum WorkerWakeupStrategy WORKER_WAKEUP_STRATEGY =
		WorkerWakeupStrategy::EMPER_WORKER_WAKEUP_STRATEGY;

static const bool LIBURCU =
#ifdef EMPER_LIBURCU
		true
#else
		false
#endif
		;

static const bool DEBUG =
#ifndef NDEBUG
		true
#else
		false
#endif
		;

static const bool LOG_TIMESTAMP =
#ifdef EMPER_LOG_TIMESTAMP
		true
#else
		false
#endif
		;

static const bool OVERFLOW_QUEUE =
#ifdef EMPER_OVERFLOW_QUEUE
		true
#else
		false
#endif
		;

auto getFullVersion() -> std::string;

static const bool BLOCKED_CONTEXT_SET =
#ifdef EMPER_BLOCKED_CONTEXT_SET
		DEBUG
#else
		false
#endif
		;

static const bool IO =
#ifdef EMPER_IO
		true
#else
		false
#endif
		;

static const bool IO_URING_SQPOLL =
#ifdef EMPER_IO_URING_SQPOLL
		true
#else
		false
#endif
		;
}	 // namespace emper
