// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus
#pragma once

#include "Fiber.hpp"
#include "emper-common.h"
#include "lib/adt/MpscQueue.hpp"
#include "strategies/AbstractWorkStealingScheduler.hpp"

class LawsStrategy;
class Runtime;
struct NextFiberResult;

class LawsScheduler : public AbstractWorkStealingScheduler {
	using LawsMpscQueue = adt::MpscQueue<Fiber>;

 private:
	LawsMpscQueue** priorityQueues;

	static thread_local LawsMpscQueue priorityQueue;

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wattributes"
	LawsStrategy& lawsStrategy
#ifndef EMPER_STATS
			ATTR_UNUSED
#endif
			;
#pragma GCC diagnostic pop

 protected:
	void scheduleInternal(Fiber& fiber) override;

 public:
	LawsScheduler(Runtime& runtime, LawsStrategy& lawsStrategy);

	auto nextFiber() -> NextFiberResult override;
};
