// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus
#include "LawsStrategy.hpp"

#include "strategies/laws/LawsDispatcher.hpp"			// for LawsDispatcher
#include "strategies/laws/LawsScheduler.hpp"			// for LawsScheduler
#include "strategies/laws/LawsStrategyStats.hpp"	// for LawsStrategyStats

LawsStrategy::LawsStrategy(Runtime& runtime)
		: scheduler(runtime, *this),
			dispatcher(runtime, *this),
			scheduledFibersToRemotePriority(0),
			dispatchedFiberFromPriority(0),
			dispatchedFiberFromLocal(0),
			dispatchedFiberStolen(0),
			dispatchedFiberFromAnywhere(0) {}

auto LawsStrategy::getScheduler() -> LawsScheduler& { return scheduler; }

auto LawsStrategy::getDispatcher() -> LawsDispatcher& { return dispatcher; }

auto LawsStrategy::getStats() -> std::shared_ptr<RuntimeStrategyStats> {
	return std::make_shared<LawsStrategyStats>(*this);
}
