// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus
#pragma once

#include <cstdint>

#include "strategies/AbstractWorkStealingStats.hpp"

class LawsStrategy;

class LawsStrategyStats : public AbstractWorkStealingStats {
 private:
	const uint64_t scheduledFibersToRemotePriority;
	const uint64_t dispatchedFiberFromPriority;
	const uint64_t dispatchedFiberFromLocal;
	const uint64_t dispatchedFiberStolen;
	const uint64_t dispatchedFiberFromAnywhere;

 public:
	LawsStrategyStats(LawsStrategy& lawsStrategy);

	[[nodiscard]] auto getScheduledFibersToRemotePriority() const -> uint64_t;
	[[nodiscard]] auto getDispatchedFiberFromPriority() const -> uint64_t;
	[[nodiscard]] auto getDispatchedFiberFromLocal() const -> uint64_t;
	[[nodiscard]] auto getDispatchedFiberStolen() const -> uint64_t;
	[[nodiscard]] auto getDispatchedFiberFromAnywhere() const -> uint64_t;

	void print() override;
};
