// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Fischer
#include <liburing.h>

#include <array>		// for array
#include <cstdlib>	// for exit, EXIT_SUCCESS, size_t

#include "emper-config.h"	 // for EMPER_IO_WORKER_URING_ENTRIES
#include "io/Future.hpp"	 // for AlarmFuture

using emper::io::AlarmFuture;

void emperTest() {
	const size_t links = EMPER_IO_WORKER_URING_ENTRIES * 2;
	std::array<AlarmFuture*, links> futures;
	struct __kernel_timespec ts = {.tv_sec = 0, .tv_nsec = 100};

	for (unsigned i = 0; i < links; ++i) {
		auto* future = new AlarmFuture(ts);
		if (i > 0) {
			future->setDependency(*futures[i - 1]);
		}

		futures[i] = future;
	}

	futures[links - 1]->submitAndWait();
	exit(EXIT_SUCCESS);
}
