// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus, Florian Fischer
#include "test-runner.hpp"

#include <cstdlib>
#include <iostream>

#include "Fiber.hpp"
#include "Runtime.hpp"

void invokeTest() {
	emperTest();

	exit(EXIT_SUCCESS);
}

auto testMain() -> int {
	if (!&emperTest) {
		std::cerr << "ERROR: The emperTest() method is not defined.";
		return EXIT_FAILURE;
	}

	Runtime runtime;

	Fiber* alphaFiber = Fiber::from(&invokeTest);

	runtime.scheduleFromAnywhere(*alphaFiber);

	runtime.waitUntilFinished();

	return EXIT_FAILURE;
}
